-- Author      : admin
-- Create Date : 10/13/2019 2:30:17 PM

do
    local a = newArray();

    local b = a.slice();

    assert(#a == 0, 'expect #a to be 0');
    assert(#b == 0, 'expect #b to be 0');
end

do
    local a = newArray(1, 2, 3);

    local b = a.slice();

    assert(#a == 3, 'expect #a to be 3');
    assert(#b == 3, 'expect #b to be 3');
end

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);

    local b = a.slice(6, 3);

    assert(#a == 9, 'expect #a to be 9');
    assert(#b == 0, 'expect #b to be 0');
end
do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);

    local b = a.slice(5);

    assert(#a == 9, 'expect #a to be 9');
    assert(#b == 5, 'expect #b to be 5');
    assert(b[1] == a[5]);
    assert(b[2] == a[6]);
    assert(b[3] == a[7]);
    assert(b[4] == a[8]);
    assert(b[5] == a[9]);
end

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);

    local b = a.slice(5, 7);

    assert(#a == 9, 'expect #a to be 9');
    assert(#b == 3, 'expect #b to be 5');
    assert(b[1] == a[5]);
    assert(b[2] == a[6]);
    assert(b[3] == a[7]);
end

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);

    local b = a.slice(-4, -2);

    assert(#a == 9, 'expect #a to be 9');
    assert(#b == 3, 'expect #b to be 5');
    assert(b[1] == a[5]);
    assert(b[2] == a[6]);
    assert(b[3] == a[7]);
end

